﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TSPForm
{
    public partial class FrmGreedy : Form
    {
        FrmTSPSolver frmTSPSolver;//parent form of this form
        public FrmGreedy(FrmTSPSolver frmTSPSolver)
        {
            this.frmTSPSolver = frmTSPSolver;
            InitializeComponent();
        }

        private void FrmGreedy_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Dispose();//clearn up all resources used 
        }

        private void btnCancle_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnBeginGreedy_Click(object sender, EventArgs e)
        {
            #region Parameter  Check
            if (textBoxStartCityNo.Text.Trim().Length <= 0)
            {
                MessageBox.Show("Please input the Parameter of start city of TSP ! ");
                textBoxStartCityNo.Focus();
                return;
            }
            else
            {
                try
                {
                    CAppParamter.iStartCityNo = int.Parse(textBoxStartCityNo.Text.Trim());
                    if (CAppParamter.iStartCityNo < 1)
                    {
                        MessageBox.Show("Parameter of start city No must be bigger than one  !");
                        textBoxStartCityNo.Focus();
                        return;
                    }
                    if (CAppParamter.iStartCityNo > CAppParamter.iCityCount)
                    {
                        MessageBox.Show("Parameter of start city No must be smaller than the maximum  count of cities!");
                        textBoxStartCityNo.Focus();
                        return;
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show("Please check out the Parameter ofstart city No! ");
                    textBoxStartCityNo.Focus();
                    return;
                }
            }
            #endregion

            #region  Start Greedy Algorithm
            frmTSPSolver.BeginGreedyThread();//start greedy algorithm 
            this.Close(); //Close the form of parameter set 
            #endregion
        }

        private void textBoxStartCityNo_TextChanged(object sender, EventArgs e)
        {

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }
    }
}
